﻿;; -*-mode: ahk; coding:utf-8-with-signature-dos-*-"
#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir%
#SingleInstance force
#persistent

ini_filename := "run-dvorakj-and-other-application.ini"
for k,v in ["dvorakj_path", "application_path"] {
    IniRead, %v%, %ini_filename%, path, %v%
}
for k,v in ["interval_of_watching_process"] {
    IniRead, %v%, %ini_filename%, time, %v%
}

for k,v in [dvorakj_path, application_path] {
    if !FileExist(v) {
        MsgBox,% "Error: " . v "is not found."
        ExitApp
    }
}

if !check_dvorakj() {
    run,% dvorakj_path
}

run,%application_path%, , , OutputVarPID
SetTimer, watching_process, %interval_of_watching_process%
OnExit, ExitSub
return


check_dvorakj(){
    rslt := False
    for process in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process") {
        if InStr(process.CommandLine, "DvorakJ.ahk")
            rslt := True

        if InStr(process.Name, "DvorakJ.exe")
            rslt := True

        if (rslt)
            return True
    }
    
    return False
}



watching_process:
    if !check_dvorakj() {
        GoTo, ExitSub
    }
return


ExitSub:
    Process, Close, %OutputVarPID%
    ExitApp
    return

